#include <stdio.h>
#include <math.h>
#include <list>

using namespace std;
#define MAXV 50001
#define MAXE 1000000
#define DUZO 1000000000

typedef struct qqqq {
int w,t,a,l,e;
qqqq(int ww,int tt,int aa,int ll,int ee):w(ww),t(tt),a(aa),l(ll),e(ee){};
} vert;

list<vert> lista[MAXV];

int V[MAXV];
int Q[MAXV];
int n,m,q_size;

int extract_min(void);
void get_ready_queue(void);
void read_data(void);
void get_ready(void);
void solve(void);
void answer(void);

int main(void) {
int i,d;
scanf("%d",&d);
for(i=0; i<d; ++i) {
//printf("a\n");
scanf("%d %d",&n,&m);
get_ready();
read_data();
//printf("b\n");

get_ready_queue();
//printf("c\n");
solve();
//printf("d\n");
answer();
}
return 0;
}

void get_ready_queue() {
int i;
for (i=1; i<=n; ++i) Q[i]=1;
q_size=n;
}

void read_data() {
int i,a,w,t,l,e,v;
for (i=0; i<m ; ++i) {
	scanf("%d %d %d %d %d %d",&v,&e,&w,&t,&a,&l);
	lista[v].push_back(vert(w,t,a,l,e));
}	
}

void get_ready() {
int i;
for (i=1; i<=n; ++i) {
	V[i] = DUZO;
	lista[i].clear();
}
}

int extract_min() {
int i,min,min_i;
min_i = -1;
min = DUZO;

for (i=1; i<=n ; ++i)
	if (Q[i] && V[i]<=min) {
	min =  V[i];
	min_i = i;
}

Q[min_i] = 0;
--q_size;
return min_i;
}

void answer() {
if (V[n]==DUZO) printf("NIE\n");
else printf("%d\n",V[n]);
}

void solve() {
int i,j,a,z,temp;
list<vert>::iterator it;
vert v(0,0,0,0,0);
V[1] = 0;
while(q_size) {
//	printf("extract\n");
	a = extract_min();
	it = lista[a].begin();
	while (it != lista[a].end()) {
		v = *it;
		if (v.t==0 && v.t==v.a && v.t == v.l) temp = V[a] + v.w;
		else if (v.l>=v.w) {
//		if (V[a]<v.a) temp = v.a+v.w;
//		else {
			z = (V[a]-v.a+v.t)%v.t;
			if (z>v.l-v.w) temp = V[a] + v.w + v.t - z ;
			else temp = V[a] + v.w ;
//			}
		}
		else temp = -1;
		if (temp >= 0 && temp < V[v.e]) V[v.e] = temp;
//printf ("a = %d",a);
//for (j=0; j<=n ; ++j ) printf ("%d: %d    ",j,V[j]);
//printf("\n");
	++it;
	}
	}
}

