#include <stdio.h>
#include <vector>
#include <string.h>
#include <algorithm>

using namespace std;

int d;
int p;
int q;
const int maxw = 100001;

typedef struct  {
	int w;
	int jd;
	int przel;
}wartosc;
int cnj;
char nj[6][11];

int find(char *nazwa)
{
	for (int i=0;i<cnj;++i)
		if (strcmp(nj[i],nazwa) == 0)
			return i;
	strcpy(nj[cnj++],nazwa);
	return cnj - 1;
}

void add(char *nazwa,int num)
{
	string ss(nazwa);
	nj[ss] = num;
}

wartosc w[maxw];

int przel[4][4];
int num = 0;
int najm = 0;

void read()
{
	char n1[11];
	char n2[11];

	scanf("%d",&p);
	num = 0;

	for (int i=0;i<4;++i)
		for (int j=0;j<4;++j)
			przel[i][j] = -1;

	nj.clear();

	for (int i=0;i<p;++i) {
		int w1,p1;
		int ww,pp;
		scanf("%d %s = %d %s",&w1,n1,&p1,n2);
		ww = find(n1);
		pp = find(n2);

		przel[ww][pp] = p1;	
		przel[i][i] = 1;
	}
	for (int i=0;i<cnj;++i)
		for (int j=i+1;j<cnj;++j)
			for (int k=0;k<cnj;k++) 
				if (przel[i][j] == -1) 
					if (przel[i][k] != -1 && przel[k][j] != -1)
						przel[i][j] = przel[i][k]*przel[k][j];
	najm = 0;
	for (int i=1;i<num;++i) 
		if (przel[0][i] > przel[0][najm]) najm = i;	
	printf("map.soize = %d\n",nj.size());

//	printf("najm = %d\n",najm);
	scanf("%d",&q);
	int ww;
	for (int i=0;i<q;++i) {
		scanf("%d %s",&ww,n1);
		w[i].w  =ww;
		w[i].jd = find(n1);
	}
	
}

bool operator<(const wartosc& w1,const wartosc &w2)
{
	long long wl1 = w1.w *  przel[w1.jed][najm];
	long long wl2 = w2.w * przel[w2.jed][najm];
	if (wl1 == wl2)
		return w1.jd - w2.jd;
	return wl1<wl2;
}

int dist(int num)
{
	long long wl1 = w[maxw].w *  przel[w[maxw].jed][najm];
	long long wl2 = w[num].w * przel[w[num].jed][najm];
	return (int)abs(wl1-wl2);
}

int bs(int l,int r)
{
	if (l == r -1) {
		if (dist(l) < dist(best))
			return l;
		return best;
	}
	int m = (l+r)>>1;
	int dx = d(m);
	if (dx == 0) return m;
	else if (w[m] < w[maxw])
		return bs(l,m);
	return bs(m+1,r);
}

int solve()
{
		int czap;
		sort(w,w+q);
		scanf("%d",&czap);
		for (int i=0;i<czap;++i) {
		int ww;
		char n1[11];
		scanf("%d %s",&ww,n1);
		w[maxw].w  =ww;
		w[maxw].jd = find(n1);
		best = 0;
		int res = bs(0,q);
		printf("%d %s\n",w[res].w,nj[w[res].jed]);
		}
}

int main()
{
	scanf("%d",&d);
	for (int i=0;i<d;++i) {
		read();
		solve();
	}
	return 0;
}
